# Youkai Yashiki (MSX, CASIO, 1986) - Graphics patch


## Description

This is a graphical patch for the game _Youkai Yashiki_ (CASIO, 1986), also known as _Ghost House_, for MSX.

The patch is offered in two flavours:
- JP, with the original items (onigiri, omamori, geta shoes...) and original ending message
- EN, with reworked items (hamburguer, four leaf clover, sneakers...) and translated ending message.


## Credits

Graphics by [**@yazioh**](twitter.com/yazioh). All rights reserved.

Reverse engineering and code patches by [**@NestorSancho**](twitter.com/NestorSancho).


## License

This work is licensed under the [**Attribution-NonCommercial-NoDerivatives 4.0 International (CC BY-NC-ND 4.0)**](http://creativecommons.org/licenses/by-nc-nd/4.0/) license.

This license allows reusers to copy and distribute the material in any medium or format in unadapted form only, for noncommercial purposes only, and only so long as attribution is given to the creator.

CC BY-NC-ND includes the following elements:
- BY: Credit must be given to the creator
- NC: Only noncommercial uses of the work are permitted
- ND: No derivatives or adaptations of the work are permitted

Please note that hacks and/or ports to run the patched game on different platforms than MSX (such as ColecoVision, Sega SG-1000 or Sega Master System) are considered derivative and/or adaptations of the work, and therefore are not permitted by this license.


## ROM information

These patches has been designed to be applied over the following ROM:

- Name: `Yokai Yasiki (1986) (Casio) (J).rom`

	ROM CRC32: `2FAF6E26`

	ROM MD5: `BCEC9FDAC121E3EE668946CDBEDF63CF`

The resulting ROM(s) should match the following checksums:

- JP patched version:

	- ROM CRC32: `1F1E5B01`

		ROM MD5: `162CAB85324D4F5CDD3DCB5E9C247743`

- EN patched version:

	- ROM CRC32: `2239EAF2`

		ROM MD5: `FCFC6D19B00BC061A5B62508C6FE0D8F`


## Detailed change list

The new graphics comprises:
- New main charset in two variants (JP and EN), and extended to include alphanumeric characters
- New sprite sheet
- New bosses charset

The graphic-related code changes comprises:
- Map definition multiplexed to save bytes
- Room definitions rewritten to use new modes and include new decorations
- Decoration data reorganized to save bytes and include new decorations
- Graphic data reorganized to include alphanumeric characters and allow routine optimizations to save bytes
- Cartridge initialization routine relocated and optimized to save bytes
- Koji (player) and Rika (girl) sprite colors patched
- Blinking scroll item routine patched to preserve CLRTBL data (instead of "flat" FILVRM)
- Floor recoloring routine patched to use alternative CLRTBL data (instead of "flat" FILVRM)
- Y-coordinate of some sprites patched to prevent glitches due the new graphics being taller
- Room decoding routine rewritten with new modes and to allow more compact room definitions to save bytes
- Fire printing routine patched to save bytes
- HUD printing routines patched to save characters
- Tongue monster printing routine patched due the new graphic being 8px taller
- Demon (enemy) routine patched to restore the lost sprite pattern when jumping

Additional code changes:
- Invulnerability cheat simplified (just <kbd>INS</kbd> + <kbd>DEL</kbd> keys)
- Scroll speed patched (slightly faster)
- WRTPSG routine patched when writing to register 7 for compatibility reasons

